
![](https://colibri-engine.com/assets/img/compute.png)

![](https://img.shields.io/npm/types/@compute.ts/structural)
![](https://img.shields.io/npm/v/@compute.ts/structural)
![](https://img.shields.io/npm/l/@compute.ts/structural)
![](https://img.shields.io/badge/coverage-88.06%25-4cc41f.svg)
![](https://img.shields.io/badge/files-6-orange)
![](https://img.shields.io/badge/lines-100-orange)
![](https://img.shields.io/badge/made%20in-France-blue)


## Presentation
The engine is based on incremental computation algorithms. When a calculation is submitted to the engine, all the computed values are memorized. So, if you change some variable and query an evaluation, the engine is able to compute the result very fast because it recomputes only what has changed.



## Libraries
The project provides several libraries that each comes with dozens of operators. Please note the cross-compatibility of the libraries.
- [@compute.ts/boolean](https://www.npmjs.com/package/@compute.ts/boolean)
- [@compute.ts/number](https://www.npmjs.com/package/@compute.ts/number)
- [@compute.ts/string](https://www.npmjs.com/package/@compute.ts/string)
- [@compute.ts/date](https://www.npmjs.com/package/@compute.ts/date)
- [@compute.ts/dictionary](https://www.npmjs.com/package/@compute.ts/dictionary)
- [@compute.ts/array](https://www.npmjs.com/package/@compute.ts/array)
- [@compute.ts/function](https://www.npmjs.com/package/@compute.ts/function)
- [@compute.ts/math](https://www.npmjs.com/package/@compute.ts/math)


## Imports
### Typescript
```typescript
import {/* required operators */} from '@compute.ts/structural';
```

### Javascript
```javascript
const {/* required operators */} = require('@compute.ts/structural');
```

## Operators
### If

<code>If(x<sub>boolean</sub>).*asType*.then(y<sup>1</sup><sub>*type*</sub>).else(y<sup>2</sup><sub>*type*</sub>) ➜ z<sub>*type*</sub></code>  

The **If** operator allows to create a typed expression which evals to a node value depends on a boolean node evaluation.

```typescript
import {boolean} from "@compute.ts/boolean";
import {number} from "@compute.ts/number";
import {If} from "@compute.ts/structural";

const x = boolean();  
const y1 = number();  
const y2 = number();  
const z = If(x).asNumber.then(y1).else(y2);
```


## About the author
I am a software developer with 4 years of project specializing in the development of web solutions. Digital Nomad, I work while traveling.  After 3 years into the french industry, I've started to work as a freelance software architect or fullstack developer.

Based on state-of-the-art web technologies, I offer you to architect & develop the best version of your project. My experience in the web app development assure you to build a nice looking, performant and stable product.

Minimalist, I like to travel, to meet people, learn new things and handmade stuff. Scuba & sky diving licenced. I like also hamburgers, Kinder chocolate and crepes. Karate black belt.

https://berthellemy.com/

* * *

![](https://colibri-engine.com/assets/img/brand/logo_animated.gif)
